unit unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons,inifiles;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    SpeedButton2: TSpeedButton;
    rg1: TRadioGroup;
    SpeedButton1: TSpeedButton;
    Panel2: TPanel;
    Image1: TImage;
    procedure Button1Click(Sender: TObject);
    procedure rg1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure myclick(sender:tobject);
    procedure mymouseMove(sender:tobject;Shift: TShiftState; X, Y: Integer);
    procedure myMouseDown(Sender: TObject; Button: TMouseButton;
              Shift: TShiftState; X, Y: Integer);
    procedure myMouseUp(Sender: TObject; Button: TMouseButton;
              Shift: TShiftState; X, Y: Integer);
    procedure save;
    procedure load;
  end;

var
  Form1: TForm1;
  xx,yy:integer;//ʰѼ
  inifile:string;//iniɸ|[ɦW
const
  coloron=clred;
  coloroff=clyellow;
  x0=10;//x_I
  y0=10;//y_I
  iw=50;//e
  ih=30;//
  x00=5; //
  y00=5; //
  max=50;//qx

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
      i:integer;
      LB:tlabel;
      mg:timage;
      Sx,Sy:integer;//̫@xxyb_I
begin
   assert(strtoint(edit1.text) in [1..max],'пJ1'+inttostr(max));

   image1.Parent:=self;
   for i:=0 to panel2.ControlCount-1 do begin
       panel2.Controls[0].Free;
   end;

   sx:=x0;
   sy:=y0;

   for i:=1 to strtoint(edit1.text) do
   begin
       LB:=tlabel.Create(self);
       LB.Parent:=panel2;
       LB.Color:=coloroff;
       LB.Width:=iw;
       LB.Height:=ih;
       LB.AutoSize:=false;
       LB.Caption:='PC'+inttostr(i);
       LB.name:='PC'+inttostr(i);
       LB.Alignment:=tacenter;
       LB.Layout:=tlcenter;
       lb.OnClick:=myclick;

       if (sx+iw)>panel2.width then begin
          sx:=x0;
          sy:=sy+ih+y00;
       end;

       LB.Left:=SX;
       LB.Top:=SY;
       sx:=sx+iw+x00;
   end;
   image1.Parent:=panel2;
   image1.SendToBack; 
   //ͧNxs@
   save;

end;


procedure TForm1.myclick(sender: tobject);
var LB:tlabel;
begin
    LB:=tlabel(sender);
    if LB.Color=coloron then
    begin
       LB.Color:=coloroff;
    end
    else
    begin
       LB.Color:=coloron;
    end;
end;

procedure TForm1.myMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var ctl:tcontrol;
begin
     ctl:=tcontrol(sender);
     setcapturecontrol(ctl);
     xx:=x;
     yy:=y;
end;

procedure TForm1.mymouseMove(sender: tobject; Shift: TShiftState; X,
  Y: Integer);
var ct:tcontrol;
begin
       ct:=getcapturecontrol;
       if ct =nil then exit;
       ct.left:=ct.left+x-xx;
       ct.top:=ct.top+y-yy;
end;

procedure TForm1.myMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
      releasecapture;
end;

procedure TForm1.rg1Click(Sender: TObject);
var i:integer;
begin
     case rg1.ItemIndex of
     0:
       begin
         for i:=0 to panel2.ControlCount-1 do begin
             tpanel(panel2.Controls[i]).OnMouseMove:=mymousemove;
             tpanel(panel2.Controls[i]).OnMousedown:=mymousedown;
             tpanel(panel2.Controls[i]).OnMouseup:=mymouseup;
             tpanel(panel2.Controls[i]).OnClick:=nil;
         end;
       end;
     1:
       begin
         for i:=0 to panel2.ControlCount-1 do begin
             tpanel(panel2.Controls[i]).OnMouseMove:=nil;
             tpanel(panel2.Controls[i]).OnMousedown:=nil;
             tpanel(panel2.Controls[i]).OnMouseup:=nil;
             tpanel(panel2.Controls[i]).OnClick:=myclick;             
         end;
       end;
     end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var bmp:tbitmap;
begin
   inifile:=extractfilepath(application.exename)+'sys.ini';
//   load;
end;

procedure TForm1.save;
var n:tinifile;
    i:integer;
    LB:tlabel;
begin
    n:=tinifile.create(inifile);

    n.WriteInteger('sys','count',panel2.ControlCount);
    for i:=0 to panel2.ControlCount-1 do begin
       if panel2.Controls[i] is tlabel then begin
         LB:=tlabel(panel2.controls[i]);
         n.WriteString(LB.Name,'caption',LB.Caption);
         n.Writeinteger(LB.Name,'left',LB.left);
         n.Writeinteger(LB.Name,'top',LB.top);
         n.Writeinteger(LB.Name,'width',LB.width);
         n.Writeinteger(LB.Name,'height',LB.height);
       end;
    end;
    n.free;

end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  save;
end;

procedure TForm1.load;
var n:tinifile;
    i,icount:integer;
    LB:tlabel;
begin
    n:=tinifile.create(inifile);
    icount:=n.ReadInteger('sys','count',0);

    image1.Parent:=self;

    for i:=0 to panel2.Controlcount-1 do begin
        panel2.Controls[0].Free;
    end;

    for i:=1 to icount do begin
         LB:=tlabel.Create(self);
         LB.Parent:=panel2;
         LB.Color:=coloroff;
         LB.AutoSize:=false;
         LB.Alignment:=tacenter;
         LB.Layout:=tlcenter;
         lb.OnClick:=myclick;

         LB.caption:=n.Readstring('PC'+inttostr(i),'caption','');
         LB.name:=lb.caption;
         LB.Width:=n.ReadInteger('PC'+inttostr(i),'width',0);
         LB.height:=n.ReadInteger('PC'+inttostr(i),'height',0);
         LB.top:=n.ReadInteger('PC'+inttostr(i),'top',0);
         LB.left:=n.ReadInteger('PC'+inttostr(i),'left',0);
    end;

    image1.Parent:=panel2;
    image1.SendToBack;

    n.free;
    
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  load;
end;

end.
